config/routes.rb
Rails.application.routes.draw do

  devise_for :users, controllers: {omniauth_callbacks: "omniauth_callbacks"}

  resources :books

  root 'books#index'

end

app/models/book.rb
class Book < ActiveRecord::Base
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and
  devise :database_authenticatable, :registerable,  :omniauthable,
         :recoverable, :rememberable, :trackable, :validatable, :confirmable, :lockable

       validates_presence_of :username
       validates_uniqueness_of :username

       def self.from_omniauth(auth)
         where(provider: auth.provider, uid: auth.uid).first_or_create do |user|
            user.provider = auth.provider
            user.uid = auth.uid
            user.username = auth.info.nickname
          end
      end

      def self.new_with_session(params, session)
       if session["devise.user_attributes"]
         new(session["devise.user_attributes"], without_protection:true) do |user|
             user.attributes = params
             user.valid?
       end
       else
         super
       end
   end

   def password_required?

     super && provider.blank?

   end

   def email_required?

     super && provider.blank?

   end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  before_action :authenticate_user!

  before_action :configure_permitted_parameters, if: :devise_controller?

 protected
 def configure_permitted_parameters
   devise_parameter_sanitizer.permit(:sign_up, keys: [:username])
   devise_parameter_sanitizer.permit(:sign_up, keys: [:city])
   devise_parameter_sanitizer.permit(:account_update, keys: [:username])
   devise_parameter_sanitizer.permit(:account_update, keys: [:city])
 end
end

app/controllers/books_controller.rb
class BooksController < ApplicationController
  before_action :set_book, only: [:show, :edit, :update, :destroy]

  # GET /books
  # GET /books.json
  def index
    @books = Book.all
  end

  # GET /books/1
  # GET /books/1.json
  def show
  end

  # GET /books/new
  def new
    @book = Book.new
  end

  # GET /books/1/edit
  def edit
  end

  # POST /books
  # POST /books.json
  def create
    @book = Book.new(book_params)

    respond_to do |format|
      if @book.save
        format.html { redirect_to @book, notice: 'Book was successfully created.' }
        format.json { render :show, status: :created, location: @book }
      else
        format.html { render :new }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /books/1
  # PATCH/PUT /books/1.json
  def update
    respond_to do |format|
      if @book.update(book_params)
        format.html { redirect_to @book, notice: 'Book was successfully updated.' }
        format.json { render :show, status: :ok, location: @book }
      else
        format.html { render :edit }
        format.json { render json: @book.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /books/1
  # DELETE /books/1.json
  def destroy
    @book.destroy
    respond_to do |format|
      format.html { redirect_to books_url, notice: 'Book was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_book
      @book = Book.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def book_params
      params.require(:book).permit(:title, :review)
    end
end

app/controllers/omniauth_callbacks_controller.rb
class OmniauthCallbacksController < Devise::OmniauthCallbacksController

  def all
    user = User.from_omniauth(request.env["omniauth.auth"])
    session["devise.user_attributes"]= user.attributes
    if user.persisted?
      flash[:notice] = "Successfully signed in!"
      sign_in_and_redirect user
    else

      redirect_to new_user_registration_path

    end
  end

  alias_method :twitter, :all


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/books_helper.rb
module BooksHelper
end

app/helpers/omniauth_callbacks_helper.rb
module OmniauthCallbacksHelper
end

app/views/books/_form.html.erb
<%= form_for(@book) do |f| %>
  <% if @book.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@book.errors.count, "error") %> prohibited this book from being saved:</h2>

      <ul>
      <% @book.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %><br>
    <%= f.text_field :title %>
  </div>
  <div class="field">
    <%= f.label :review %><br>
    <%= f.text_field :review %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/books/edit.html.erb
<h1>Editing Book</h1>

<%= render 'form' %>

<%= link_to 'Show', @book %> |
<%= link_to 'Back', books_path %>

app/views/books/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Books</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Review</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @books.each do |book| %>
      <tr>
        <td><%= book.title %></td>
        <td><%= book.review %></td>
        <td><%= link_to 'Show', book %></td>
        <td><%= link_to 'Edit', edit_book_path(book) %></td>
        <td><%= link_to 'Destroy', book, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Book', new_book_path %>

app/views/books/new.html.erb
<h1>New Book</h1>

<%= render 'form' %>

<%= link_to 'Back', books_path %>

app/views/books/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @book.title %>
</p>

<p>
  <strong>Review:</strong>
  <%= @book.review %>
</p>

<%= link_to 'Edit', edit_book_path(@book) %> |
<%= link_to 'Back', books_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Appdevise</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<% if user_signed_in? %>
 Logged in as <strong><%= current_user.username %></strong>
 <%= link_to 'Edit profile', edit_user_registration_path, :class => 'navbar-link' %>
 <%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
 <% else %>
 <%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link'  %>
 <%= link_to "Sign in with twitter", user_twitter_omniauth_authorize_path(),  :class => 'navbar-link'  %>
 <%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
<% end %>




<% if notice %>
 <p class="alert alert-success"><%= notice %></p>
<% end %>
<% if alert %>
 <p class="alert alert-danger"><%= alert %></p>
<% end %>
<%= yield %>



</body>
</html>